

--[[
This part is entirely made by Engin33r.
Visit him: http://engin33r.net
Thank you so much for sharing it. It's amazing! :)
Especially the fixed version. :P
]]


vl={}

function initArray2(f,v)
	local cmd={}
	for c=1,f do
		cmd[c]=v
	end
	return cmd
end

function doublearray(m,n,k)
    local a, x, y = {}
    for x = 0, m do a[x] = {}
        for y = 0, n do
            a[x][y] = k or 0
        end
    end
    return a
end

function table.contains(table, element)
    for _, value in pairs(table) do
        if value == element then
            return true
        end
    end
    return false
end


vl.buttonstyles={ -- This is the button styles table - just follow the model of the first default style to create your own!

	[0] = {
		name="0",
		image="gfx/tajifuns_rpg/spells/empty.png",
		hover="gfx/tajifuns_rpg/spells/empty.png",
		click="gfx/tajifuns_rpg/spells/empty_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},

	[1] = {
		name="spell1",
		image="gfx/tajifuns_rpg/spells/selfheal.png",
		hover="gfx/tajifuns_rpg/spells/selfheal.png",
		click="gfx/tajifuns_rpg/spells/selfheal_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[2] = {
		name="spell2",
		image="gfx/tajifuns_rpg/spells/growth.png",
		hover="gfx/tajifuns_rpg/spells/growth.png",
		click="gfx/tajifuns_rpg/spells/growth_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[3] = {
		name="spell3",
		image="gfx/tajifuns_rpg/spells/preciseblock.png",
		hover="gfx/tajifuns_rpg/spells/preciseblock.png",
		click="gfx/tajifuns_rpg/spells/preciseblock_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[4] = {
		name="spell4",
		image="gfx/tajifuns_rpg/spells/meteor.png",
		hover="gfx/tajifuns_rpg/spells/meteor.png",
		click="gfx/tajifuns_rpg/spells/meteor_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[5] = {
		name="spell5",
		image="gfx/tajifuns_rpg/spells/sprint.png",
		hover="gfx/tajifuns_rpg/spells/sprint.png",
		click="gfx/tajifuns_rpg/spells/sprint_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[6] = {
		name="spell6",
		image="gfx/tajifuns_rpg/spells/lifesaver.png",
		hover="gfx/tajifuns_rpg/spells/lifesaver.png",
		click="gfx/tajifuns_rpg/spells/lifesaver_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[7] = {
		name="spell7",
		image="gfx/tajifuns_rpg/spells/ambitioussacrifice.png",
		hover="gfx/tajifuns_rpg/spells/ambitioussacrifice.png",
		click="gfx/tajifuns_rpg/spells/ambitioussacrifice_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[8] = {
		name="spell8",
		image="gfx/tajifuns_rpg/spells/sultarsterror.png",
		hover="gfx/tajifuns_rpg/spells/sultarsterror.png",
		click="gfx/tajifuns_rpg/spells/sultarsterror_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[9] = {
		name="spell9",
		image="gfx/tajifuns_rpg/spells/oma.png",
		hover="gfx/tajifuns_rpg/spells/oma.png",
		click="gfx/tajifuns_rpg/spells/oma_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[10] = {
		name="spell10",
		image="gfx/tajifuns_rpg/spells/inertia.png",
		hover="gfx/tajifuns_rpg/spells/inertia.png",
		click="gfx/tajifuns_rpg/spells/inertia_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[11] = {
		name="spell11",
		image="gfx/tajifuns_rpg/spells/shieldwall.png",
		hover="gfx/tajifuns_rpg/spells/shieldwall.png",
		click="gfx/tajifuns_rpg/spells/shieldwall_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[12] = {
		name="spell12",
		image="gfx/tajifuns_rpg/spells/spikingivy.png",
		hover="gfx/tajifuns_rpg/spells/spikingivy.png",
		click="gfx/tajifuns_rpg/spells/spikingivy_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	[13] = {
		name="spell13",
		image="gfx/tajifuns_rpg/spells/vampirism.png",
		hover="gfx/tajifuns_rpg/spells/vampirism.png",
		click="gfx/tajifuns_rpg/spells/vampirism_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
	
	[14] = {
		name="spell14",
		image="gfx/tajifuns_rpg/spells/magicalbarrier.png",
		hover="gfx/tajifuns_rpg/spells/magicalbarrier.png",
		click="gfx/tajifuns_rpg/spells/magicalbarrier_pressed.png",
		sizex=32,
		sizey=32,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=0,
		oy=0,
	},
}


vl.currentTextID=1

vl.textpos=doublearray(1024,2,0)
vl.texttext=initArray2(1024,"")
vl.textcolor=initArray2(1024,"")

vl.plyInRange=initArray2(32,0)

vl.buttonimg=initArray2(1024,0)
vl.buttonpos=doublearray(1024,2,0)
vl.buttonsize=doublearray(1024,2,0)
vl.buttonply=initArray2(1024,0)
vl.buttonstyle=initArray2(1024,0)
vl.buttonfunc=initArray2(1024,nil)
vl.buttonhoveredupon=initArray2(1024,false)
vl.buttoncaption=initArray2(1024,0)
vl.buttonclicker=initArray2(1024,0)



-- Function: createText
-- Arguments: ply - player to be shown the text, color - the text color, text - the text itself, x - pixel X coordinate on the screen, y - pixel Y coordinate on the screen
-- Possible argument values: ply - 1-32, color - "000000000"-"255255255" (any combination), text - any string, x - 0-640, y - 0-480
function vl.createText(ply,color,text,x,y)
	local formattext=(""..color.." "..text)
	local tid=vl.currentTextID
	if ply == nil then ply = 1 end
	parse('hudtxt2 '..ply..' '..vl.currentTextID..' '..formattext..' '..x..' '..y..'')
	vl.textpos[vl.currentTextID][1]=x
	vl.textpos[vl.currentTextID][2]=y
	vl.texttext[vl.currentTextID]=text
	vl.textcolor[vl.currentTextID]=color
	vl.currentTextID=vl.currentTextID+1
	return tid
end


-- Function: removeText
-- Arguments: id - text ID
-- Possible argument values: id - 1-1024
function vl.removeText(id)
	parse('hudtxt2 0 '..id..' "" 0 0')
	vl.textpos[id][1]=0
	vl.textpos[id][2]=0
	vl.texttext[id]=0
	vl.textcolor[id]=0
end


-- Function: createButton
-- Arguments: id - button ID, ply - player to be shown the button, x - button's X position on player's screen, y - button's Y position on player's screen, style - button's style
-- Possible argument values: id - 1-1024, ply - 0-32 (0 for all players), x - 0-640, y - 0-480, style - nil-any button style ID
function vl.createButton(id,ply,x,y,style,caption,func)
	if style==nil then style=1 end
	vl.buttonimg[id]=image(vl.buttonstyles[style].image,x,y,2,ply)
	vl.buttonply[id]=ply
	vl.buttonpos[id][1]=x
	vl.buttonpos[id][2]=y
	vl.buttonsize[id][1]=vl.buttonstyles[style].sizex
	vl.buttonsize[id][2]=vl.buttonstyles[style].sizey
	vl.buttonstyle[id]=style
	vl.buttonfunc[id]=func
	if (caption~=nil) then
		vl.buttoncaption[id]=vl.createText(ply,colorcode(vl.buttonstyles[style].txtr,vl.buttonstyles[style].txtg,vl.buttonstyles[style].txtb),caption,x+vl.buttonstyles[style].ox,y+vl.buttonstyles[style].oy)
	end
end


function colorcode(r,g,b)
	if (tostring(r):len()==1) then
		r="00"..r
	elseif (tostring(r):len()==2) then
		r="0"..r
	end
	if (tostring(g):len()==1) then
		g="00"..g
	elseif (tostring(g):len()==2) then
		g="0"..g
	end
	if (tostring(b):len()==1) then
		b="00"..b
	elseif (tostring(b):len()==2) then
		b="0"..b
	end
	return r..""..g..""..b
end


-- Function: hoverButton
-- Arguments: id - button ID, ply - player hovering over the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.hoverButton(id,ply)
	--msg(vl.buttonply[id])
	--msg(ply)
	if (vl.buttonply[id]==ply) then
		freeimage(vl.buttonimg[id])
		vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].hover,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
		vl.buttonhoveredupon[id]=true
		vl.plyInRange[ply]=id
	end
end


-- Function: dehoverButton
-- Arguments: id - button ID, ply - player hovering over the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.dehoverButton(id,ply)
	if (vl.buttonhoveredupon[id] and vl.buttonply[id]==ply) then
		freeimage(vl.buttonimg[id])
		vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].image,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
		vl.buttonhoveredupon[id]=false
		vl.plyInRange[ply]=0
	end
end


-- Function: buttonCLick
-- Arguments: id - button ID, ply - player clicking the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.buttonClick(id,ply)
	freeimage(vl.buttonimg[id])
	vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].click,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
	vl.buttonclicker[id]=ply
	timer(100,"parse","lua vl.buttonUnclick("..id..","..ply..")")
end


-- Function: buttonUncLick
-- Arguments: id - button ID, ply - player clicking the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.buttonUnclick(id,ply)
	if (vl.buttonimg[id]~=0 and vl.buttonply[id]==ply) then
		freeimage(vl.buttonimg[id])
		vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].image,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
	end
	if (vl.buttonfunc[id]~=nil and vl.buttonply[id]==ply) then
		vl.buttonfunc[id]()
	end
	vl.buttonclicker[id]=0
end


-- Function: removeButton
-- Arguments: id - button ID
-- Possible argument values: id - 1-1024
function vl.removeButton(id)
	freeimage(vl.buttonimg[id])
	vl.buttonimg[id]=0
	vl.buttonply[id]=0
	vl.buttonpos[id][1]=0
	vl.buttonpos[id][2]=0
	vl.buttonsize[id][1]=0
	vl.buttonsize[id][2]=0
	vl.buttonstyle[id]=0
	vl.buttonfunc[id]=nil
	vl.buttonhoveredupon[id]=false
	vl.removeText(vl.buttoncaption[id])
	vl.buttoncaption[id]=0
	vl.buttonclicker[id]=0
end
	

addhook("clientdata","vl.read")
function vl.read(ply,type,a1,a2)
	if type==0 then
		for buttons=1,1024 do
			if (not player(ply,"bot")) then
				if (a1>=vl.buttonpos[buttons][1]-vl.buttonsize[buttons][1]/2 and a1<=vl.buttonpos[buttons][1]+vl.buttonsize[buttons][1]/2 and a2>=vl.buttonpos[buttons][2]-vl.buttonsize[buttons][2]/2 and a2<=vl.buttonpos[buttons][2]+vl.buttonsize[buttons][2]/2) then
					--if (vl.buttonply[buttons]==ply) then
						vl.hoverButton(buttons,ply)
					--end
				else
					--if (vl.buttonply[buttons]==ply) then
						vl.dehoverButton(buttons,ply)
					--end
				end
			end
		end
	end
end


addhook("ms100","vl.send")
function vl.send()
	for ply=1,32 do
		if (player(ply,"exists")) then
			reqcld(ply,0)
		end
	end
end


addhook("attack","vl.click")
function vl.click(ply)
	if (vl.plyInRange[ply]~=0) then
		vl.buttonClick(vl.plyInRange[ply],ply)
	end
end


