
-------------------------
--					   --
-- Tajifun's RPG Mod   --
-- v2.0				   --
-------------------------


------------
-- Engine --
------------


addhook("ms100","Sms100")
function Sms100()
	HUD()
end

addhook("join","Sjoin")
function Sjoin(id)
	--load(id)
end


addhook("spawn","Sspawn")
function Sspawn(id)
	if imgon[id] == 0 then
		hp[id] = b_hp
		mana[id] = b_mana
		atk[id] = b_atk
		def[id] = b_def
		spd[id] = b_spd
		pts[id] = startpts
		ptsused[id] = 0
		removeRects(id)
		DrawRects(id)
		interface(id)
		HUD2(id)
		load(id)
		meteorimg[id] = image("gfx/tajifuns_rpg/meteorimg.png",-10000,-10000,3,id)
		imagealpha(meteorimg[id],0)
		tween_rotateconstantly(meteorimg[id],40)
		ivyimg[id] = image("gfx/tajifuns_rpg/spikingivy.png",-10000,-10000,3,id)
		imagealpha(ivyimg[id],0)
		tween_rotateconstantly(ivyimg[id],5)
		imgon[id] = 1
	end
	hp2[id] = hp[id]
	mana2[id] = mana[id]
	parse("speedmod "..id.." "..spd[id].."")
end


addhook("leave","Sleave")
function Sleave(id)
	save(id)
	for i = 1, 9 do
		slot[id][i] = 0
	end
	reset_spells(id)
	reset_cd(id)
	meteor[id] = 0
	tween_alpha(meteorimg[id],100,0)
	tween_alpha(ivyimg[id],100,0)
	barrier[id] = 0
	clearall[id] = 0
	imgon[id] = 0
end


addhook("serveraction","Sserveraction")
function Sserveraction(id,key)
	if player(id,"health") > 0 then
		if key == 1 then
			if player(id,"health") ~= 0 then
				mainmenu(id)
			end
		end
		if key == 2 then
			if espellon[id] == 1 then
				espellon[id] = 0
				msg2(id,"255000000Quickspell off!")
			elseif espellon[id] == 0 then
				espellon[id] = 1
				msg2(id,"000255000Quickspell on!")
				if espell[id] == 0 then
					espell[id] = math.random(1,#SPELLS)
				end
			end
		end
	end
end


addhook("menu","Smenu")
function Smenu(id,menu,sel)
	
	-- SET YOUR STATS
	if menu == "Set your Stats" then
		if sel == 1 then
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		if sel == 2 then
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		-- Health
		if sel == 3 then
			if hp[id] <= (maxpt_hp-1) then
				if pts[id] >= 1 then
					hp[id] = hp[id] + 2
					pts[id] = pts[id] - 1
				else
					msg2(id,"255000000Not enough statpoints!@C")
					if ptsused[id] == 0 then
						used(id)
					end
				end
			else
				msg2(id,"255000000Already on maximum level!@C")
			end
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		-- Mana
		if sel == 4 then
			if mana[id] <= (maxpt_mana-1) then
				if pts[id] >= 1 then
					mana[id] = mana[id] + 2
					pts[id] = pts[id] - 1
				else
					msg2(id,"255000000Not enough statpoints!@C")
					if ptsused[id] == 0 then
						used(id)
					end
				end
			else
				msg2(id,"255000000Already on maximum level!@C")
			end
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		if sel == 5 then
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		-- ATK
		if sel == 6 then
			if atk[id] <= (maxpt_atk-1) then
				if pts[id] >= 1 then
					atk[id] = atk[id] + 1
					pts[id] = pts[id] - 1
				else
					msg2(id,"255000000Not enough statpoints!@C")
					if ptsused[id] == 0 then
						used(id)
					end
				end
			else
				msg2(id,"255000000Already on maximum level!@C")
			end
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		-- DEF
		if sel == 7 then
			if def[id] <= (maxpt_def-1) then
				if pts[id] >= 1 then
					def[id] = def[id] + 1
					pts[id] = pts[id] - 1
				else
					msg2(id,"255000000Not enough statpoints!@C")
					if ptsused[id] == 0 then
						used(id)
					end
				end
			else
				msg2(id,"255000000Already on maximum level!@C")
			end
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		-- SPD
		if sel == 8 then
			if spd[id] <= (maxpt_spd-1) then
				if pts[id] >= 1 then
					pts[id] = pts[id] - 1
					spd[id] = spd[id] + 1
				else
					msg2(id,"255000000Not enough statpoints!@C")
					if ptsused[id] == 0 then
						used(id)
					end
				end
			else
				msg2(id,"255000000Already on maximum level!@C")
			end
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
		if sel == 9 then
			if ptsused[id] == 0 then
				statsmenu(id)
			end
		end
	end
	
	-- MAINMENU
	if menu == "Mainmenu" then
		if sel == 1 then
			statsmenu(id)
		end
		if sel == 2 then
			skillmenu(id)
		end
		if sel == 3 then
			espellmenu(id)
		end
		if sel == 5 then
			msg2(id,"082255100Experience: "..newexp[id].." / "..newneedexp[id].." ("..(newneedexp[id]-newexp[id])..")")
		end
		if sel == 6 then
			save(id)
		end
		if sel == 8 then
			resetmenu(id)
		end
		if sel == 9 then
			help(id)
		end
	end
	
	-- Resetmenu
	if menu == "Resetmenu" then
		if sel == 1 then
			resetspells(id)
		end
		if sel == 2 then
			resetstats(id)
		end
		if sel == 9 then
			clearall[id] = 1
			msg2(id,"255000000If you really want to reset your whole game (lvl, exp, etc...), write 'YES'!")
		end
	end
	
	-- SKILLMENU
	if menu == "Skillmenu" then
		if sel >= 1 and sel <= 9 then
			if slotrecharging[id][sel] == 0 then
				spellmenu(id)
				selectedslot[id] = sel
			else
				msg2(id,"255000000You cannot change a slot with a recharging spell!@C")
			end
		end
	end
	
	-- QUICKSPELL MENU
	if menu == "Select a Spell" then
		if sel >= 1 and sel <= 7 then
			espell[id] = sel
			espellon[id] = 1
			msg2(id,"000255000Quickspell on!")
		end
		if sel == 9 then
			espellmenu2(id)
		end
	end
	
	-- QUICKSPELL MENU 2
	if menu == "Select a Spell 2" then
		if sel >= 1 and sel <= 7 then
			espell[id] = sel + 7
			espellon[id] = 1
			msg2(id,"000255000Quickspell on!")
		end
		if sel == 9 then
			espellmenu(id)
		end
	end
	
	-- SPELLMENU
	if menu == "Spellmenu" then
		for i = 1,7 do
			if sel == i then
				if cooldown_array[id][i] == 0 then
					spelltoslot(id,i,selectedslot[id])
					delete_HUD2(id)
					HUD2(id)
				else
					msg2(id,"255000000You cannot change a spell while it is recharging!@C")
				end
			end
		end
		-- Next
		if sel == 9 then
			spellmenu2(id)
		end
	end
	
	-- SPELLMENU 2
	if menu == "Spellmenu 2" then
		for i = 1,7 do
			if sel == i then
				if cooldown_array[id][(i+7)] == 0 then
					spelltoslot(id,(i+7),selectedslot[id])
					delete_HUD2(id)
					HUD2(id)
				else
					msg2(id,"255000000You cannot change a spell while it is recharging!@C")
				end
			end
		end
		-- Prev
		if sel == 9 then
			spellmenu(id)
		end
	end
	
end


addhook("hit","Shit")
function Shit(id,s,wpn,hpdmg,apdmg) -- haha fail name
	dmg = math.floor(((hpdmg)/2) + (atk[s] - (def[id]*0.3)))
	barrierdmg = math.ceil(hpdmg + atk[s])
	if dmg <= 0 then
		dmg = 1
	end
	if player(id,"team") ~= player(s,"team") then
		if barrier[id] > 0 then
			barrier[id] = barrier[id] - barrierdmg
			if barrier[id] < 0 then
				barrier[id] = 0
			end
			parse("sv_sound2 "..id.." \"tajifuns_rpg/magicalbarrier.wav\"")
			parse("sv_sound2 "..s.." \"tajifuns_rpg/magicalbarrier.wav\"")
			barrierimg[id] = image("gfx/tajifuns_rpg/barrier.png",player(id,"x"),player(id,"y"),1)
			tween_scale(barrierimg[id],150,0,0)
		else
			if shieldwall[id] == 1 then
				dmg = (math.ceil(dmg*SPELLS[11].power))
			end
			if dmg_ref[id] == 1 then
				dmg = (math.ceil(dmg/SPELLS[9].power))
			end
			if dmg >= hp2[id] then
				-- Kill
				parse('customkill '..s..' "killed" '..id..'')
				add = expratio+math.random(-10,15)
				exp[s] = exp[s] + add
				newexp[s] = newexp[s] + add
				if exp[s] >= needexp[s] then
					lvlup(s)
				end
			else
				hp2[id] = hp2[id] - dmg
			end
		end
		
	end
	return 1
end


addhook("die","Sdie")
function Sdie(id,k)
	hp2[id] = 0
	mana2[id] = 0
	reset_spells(id)
end



---------------------------
-- Spell-Cooldown System --
---------------------------

addhook("second","Ssecond")
function Ssecond()
	for id=1,32 do
		if player(id,"health") ~= 0 then
		
			-- Mana regeneration
			if mana2[id] < mana[id] then
				mana2[id] = mana2[id] + mana_reg + math.random(-2,2)
				if mana2[id] > mana[id] then
					mana2[id] = mana[id]
				end
			end
			
			-- Health regeneration
			if hp2[id] < hp[id] then
				hpreg[id] = hpreg[id] + 1
				if hpreg[id] >= 2 then
					hp2[id] = hp2[id] + hp_reg + math.random(-2,0)
					if hp2[id] > hp[id] then
						hp2[id] = hp[id]
					end
					hpreg[id] = 0
				end
			end
		end
		
		-- Inertia
		if inertiaon[id] == 1 then
			inertiaspd[id] = inertiaspd[id] + 2
			parse("speedmod "..id.." "..inertiaspd[id].."")
			if inertiaspd[id] >= 0 then
				inertiaon[id] = 0
			end
		end
		
		-- Spiking Ivy
		if ivyon[id] == 1 then
			ivytimer[id] = ivytimer[id] + 1
			if ivytimer[id] == SPELLS[12].time then
				ivytimer[id] = 0
				ivyon[id] = 0
				parse("speedmod "..id.." 0")
				--tween_alpha(ivyonimg[id], 100, 0)
			end
		end
		
		-- Shield Wall
		if shieldwall[id] == 1 then
			shieldwalltimer[id] = shieldwalltimer[id] + 1
			if shieldwalltimer[id] == SPELLS[11].time then
				shieldwalltimer[id] = 0
				shieldwall[id] = 0
			end
		end
		
		
			---------------
			-- CD SYSTEM --
			---------------
			
			-- Spell 1 (SELFHEAL)
			if cooldown_array[id][1] == 1 then
				cd_array[id][1] = cd_array[id][1] + 1
				cdtime[id][1] = SPELLS[1].cd - cd_array[id][1]
				if cdtime[id][1] <= 0 then
					cdtime[id][1] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 1 then
						parse('hudtxt2 '..id..' 10 "200200200'..cdtime[id][1]..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][1] == SPELLS[1].cd then
					cd_array[id][1] = 0
					cooldown_array[id][1] = 0
					
					for i = 1,9 do
						if slot[id][i] == 1 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[1].name.." Recharged!")
				end
			end
			
			-- Spell 2 (GROWTH)
			if cooldown_array[id][2] == 1 then
				cd_array[id][2] = cd_array[id][2] + 1
				cdtime[id][2] = SPELLS[2].cd - cd_array[id][2]
				if cdtime[id][2] <= 0 then
					cdtime[id][2] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 2 then
						parse('hudtxt2 '..id..' 11 "200200200'..cdtime[id][2]..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][2] == SPELLS[2].time then
					spell_2_end(id)
					growthon[id] = 0
				end
				if cd_array[id][2] == SPELLS[2].cd then
					cd_array[id][2] = 0
					cooldown_array[id][2] = 0
					
					for i = 1,9 do
						if slot[id][i] == 2 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[2].name.." Recharged!")
				end
			end
			
			-- Spell 3 (PRECISE BLOCK)
			if cooldown_array[id][3] == 1 then
				cd_array[id][3] = cd_array[id][3] + 1
				cdtime[id][3] = SPELLS[3].cd - cd_array[id][3]
				if cdtime[id][3] <= 0 then
					cdtime[id][3] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 3 then
						parse('hudtxt2 '..id..' 12 "200200200'..cdtime[id][3]..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][3] == SPELLS[3].time then
					spell_3_end(id)
					preciseblockon[id] = 0
				end
				if cd_array[id][3] == SPELLS[3].cd then
					cd_array[id][3] = 0
					cooldown_array[id][3] = 0
					
					for i = 1,9 do
						if slot[id][i] == 3 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[3].name.." Recharged!")
				end
			end
			
			-- Spell 4 (METEOR)
			if cooldown_array[id][4] == 1 then
				cd_array[id][4] = cd_array[id][4] + 1
				cdtime[id][4] = SPELLS[4].cd - cd_array[id][4]
				if cdtime[id][4] <= 0 then
					cdtime[id][4] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 4 then
						parse('hudtxt2 '..id..' 13 "200200200'..(cdtime[id][4])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][4] == SPELLS[4].cd then
					cd_array[id][4] = 0
					cooldown_array[id][4] = 0
					
					for i = 1,9 do
						if slot[id][i] == 4 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[4].name.." Recharged!")
				end
			end
			
			-- Spell 5 (SPRINT)
			if cooldown_array[id][5] == 1 then
				cd_array[id][5] = cd_array[id][5] + 1
				cdtime[id][5] = SPELLS[5].cd - cd_array[id][5]
				if cdtime[id][5] <= 0 then
					cdtime[id][5] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 5 then
						parse('hudtxt2 '..id..' 14 "200200200'..(cdtime[id][5])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][5] == SPELLS[5].time then
					spell_5_end(id)
				end
				if cd_array[id][5] == SPELLS[5].cd then
					cd_array[id][5] = 0
					cooldown_array[id][5] = 0
					
					for i = 1,9 do
						if slot[id][i] == 5 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[5].name.." Recharged!")
				end
			end
			
			-- Spell 6 (LIFESAVER)
			if cooldown_array[id][6] == 1 then
				cd_array[id][6] = cd_array[id][6] + 1
				cdtime[id][6] = SPELLS[6].cd - cd_array[id][6]
				if cdtime[id][6] <= 0 then
					cdtime[id][6] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 6 then
						parse('hudtxt2 '..id..' 15 "200200200'..(cdtime[id][6])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][6] == SPELLS[6].cd then
					cd_array[id][6] = 0
					cooldown_array[id][6] = 0
					
					for i = 1,9 do
						if slot[id][i] == 6 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[6].name.." Recharged!")
				end
			end
			
			-- Spell 7 (AMBITIOUS SACRIFICE)
			if cooldown_array[id][7] == 1 then
				cd_array[id][7] = cd_array[id][7] + 1
				cdtime[id][7] = SPELLS[7].cd - cd_array[id][7]
				if cdtime[id][7] <= 0 then
					cdtime[id][7] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 7 then
						parse('hudtxt2 '..id..' 16 "200200200'..(cdtime[id][7])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][7] == SPELLS[7].cd then
					cd_array[id][7] = 0
					cooldown_array[id][7] = 0
					
					for i = 1,9 do
						if slot[id][i] == 7 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[7].name.." Recharged!")
				end
			end
			
			-- Spell 8 (SULTAR'S TERROR)
			if cooldown_array[id][8] == 1 then
				cd_array[id][8] = cd_array[id][8] + 1
				cdtime[id][8] = SPELLS[8].cd - cd_array[id][8]
				if cdtime[id][8] <= 0 then
					cdtime[id][8] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 8 then
						parse('hudtxt2 '..id..' 17 "200200200'..(cdtime[id][8])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][8] == SPELLS[8].cd then
					cd_array[id][8] = 0
					cooldown_array[id][8] = 0
					
					for i = 1,9 do
						if slot[id][i] == 8 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[8].name.." Recharged!")
				end
			end
			
			-- Spell 9 (ONE-MAN-ARMY)
			if cooldown_array[id][9] == 1 then
				cd_array[id][9] = cd_array[id][9] + 1
				cdtime[id][9] = SPELLS[9].cd - cd_array[id][9]
				if cdtime[id][9] <= 0 then
					cdtime[id][9] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 9 then
						parse('hudtxt2 '..id..' 18 "200200200'..(cdtime[id][9])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][9] == SPELLS[9].time then
					spell_9_end(id)
					omaon[id] = 0
				end
				
				if cd_array[id][9] == SPELLS[9].cd then
					cd_array[id][9] = 0
					cooldown_array[id][9] = 0
					
					for i = 1,9 do
						if slot[id][i] == 9 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[9].name.." Recharged!")
				end
			end
			
			-- Spell 10 (INERTIA)
			if cooldown_array[id][10] == 1 then
				cd_array[id][10] = cd_array[id][10] + 1
				cdtime[id][10] = SPELLS[10].cd - cd_array[id][10]
				if cdtime[id][10] <= 0 then
					cdtime[id][10] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 10 then
						parse('hudtxt2 '..id..' 19 "200200200'..(cdtime[id][10])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end

				if cd_array[id][10] == SPELLS[10].cd then
					cd_array[id][10] = 0
					cooldown_array[id][10] = 0
					
					for i = 1,9 do
						if slot[id][i] == 10 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[10].name.." Recharged!")
				end
			end
			
			-- Spell 11 (FREEZING ARROW)
			if cooldown_array[id][11] == 1 then
				cd_array[id][11] = cd_array[id][11] + 1
				cdtime[id][11] = SPELLS[11].cd - cd_array[id][11]
				if cdtime[id][11] <= 0 then
					cdtime[id][11] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 11 then
						parse('hudtxt2 '..id..' 20 "200200200'..(cdtime[id][11])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end

				if cd_array[id][11] == SPELLS[11].cd then
					cd_array[id][11] = 0
					cooldown_array[id][11] = 0
					
					for i = 1,9 do
						if slot[id][i] == 11 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[11].name.." Recharged!")
				end
			end
			
			-- Spell 12 (SPIKING IVY)
			if cooldown_array[id][12] == 1 then
				cd_array[id][12] = cd_array[id][12] + 1
				cdtime[id][12] = SPELLS[12].cd - cd_array[id][12]
				if cdtime[id][12] <= 0 then
					cdtime[id][12] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 12 then
						parse('hudtxt2 '..id..' 21 "200200200'..(cdtime[id][12])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][12] == SPELLS[12].cd then
					cd_array[id][12] = 0
					cooldown_array[id][12] = 0
					
					for i = 1,9 do
						if slot[id][i] == 12 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[12].name.." Recharged!")
				end
			end
			
			-- Spell 13 (VAMPIRISM)
			if cooldown_array[id][13] == 1 then
				cd_array[id][13] = cd_array[id][13] + 1
				cdtime[id][13] = SPELLS[13].cd - cd_array[id][13]
				if cdtime[id][13] <= 0 then
					cdtime[id][13] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 13 then
						parse('hudtxt2 '..id..' 22 "200200200'..(cdtime[id][13])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][13] == SPELLS[13].cd then
					cd_array[id][13] = 0
					cooldown_array[id][13] = 0
					
					for i = 1,9 do
						if slot[id][i] == 13 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[13].name.." Recharged!")
				end
			end
			
			-- Spell 14 (MAGICAL BARRIER)
			if cooldown_array[id][14] == 1 then
				cd_array[id][14] = cd_array[id][14] + 1
				cdtime[id][14] = SPELLS[14].cd - cd_array[id][14]
				if cdtime[id][14] <= 0 then
					cdtime[id][14] = " "
				end
				
				for i = 1,9 do
					if slot[id][i] == 14 then
						parse('hudtxt2 '..id..' 23 "200200200'..(cdtime[id][14])..'" '..buttonhudtxt[i][1]..' '..buttonhudtxt[i][2]..'')
					end
				end
				
				if cd_array[id][14] == SPELLS[14].cd then
					cd_array[id][14] = 0
					cooldown_array[id][14] = 0
					
					for i = 1,9 do
						if slot[id][i] == 14 then
							slotrecharging[id][i] = 0
						end
					end
					
					msg2(id,"000250000"..SPELLS[14].name.." Recharged!")
				end
			end
	end
end


addhook("minute","Sminute")
function Sminute()
	adtime = adtime + 1
	if adtime == 2 then
		msg("234181175This Server is using Tajifun's RPG Script")
		msg("234181175I hope you like it :)")
		adtime = 0
	end
end


timer(updaterate,"requestdata","",0)
function requestdata()
	reqcld(0,2)
end


addhook("clientdata","Sclientdata")
function Sclientdata(id,mode,x,y)
	if (mode==2) then
		if player(id,"bot")==false then
			cursorx[id] = x
			cursory[id] = y
		end
		tween_move(meteorimg[id],updaterate,x,y)
		tween_move(ivyimg[id],updaterate,x,y)
	end
end


addhook("attack","Sattack")
function Sattack(id)

	if meteor[id] == 1 then
		tween_alpha(meteorimg[id],100,0)
		parse("explosion "..cursorx[id].." "..cursory[id].." "..SPELLS[4].range.." "..SPELLS[4].power.." "..id.."")
		parse("effect \"fire\" "..cursorx[id].." "..cursory[id].." 1 64 000 000 000")
		parse("effect \"smoke\" "..cursorx[id].." "..cursory[id].." 1 64 000 000 000")
		meteor[id] = 0
	end
	
	if ivy[id] == 1 then
		tween_alpha(ivyimg[id],100,0)
		for i = 1, 32 do
			if player(i,"exists") then
				if i ~= id then
					if ptoplayerdistance(i,cursorx[id],cursory[id]) <= SPELLS[12].range then
						if player(i,"team") ~= player(id,"team") then
							ivyon[i] = 1
							parse("speedmod "..i.." -100")
							parse("sv_sound2 "..i.." \"tajifuns_rpg/spikingivy2.ogg\"")
							parse("sv_sound2 "..id.." \"tajifuns_rpg/spikingivy2.ogg\"")
							aura_ivy()
							imagealpha(ivyonimg[i], 1)
							tween_alpha(ivyonimg[i], SPELLS[12].time*1000+150, 0)
							tween_rotateconstantly(ivyonimg[i], 4)
						end
					end
				end
			end
		end
		ivy[id] = 0
	end
end


addhook("use","Suse")
function Suse(id)
	if espellon[id] == 1 then
		SPELLS[espell[id]].func(id)
	end
end


addhook("say","Ssay")
function Ssay(id,txt)
	if txt == "!save" then
		save(id)
		return 1
	end
	if txt == "YES" then
		if clearall[id] == 1 then
			resetgame(id)
			clearall[id] = 0
			return 1
		end
	end
	if clearall[id] == 1 then
		clearall[id] = 0
	end
end












