
-------------------------
--					   --
-- Tajifun's RPG Mod   --
-- v2.0				   --
-------------------------


---------------
-- Functions --
---------------


-- Setup --

function initArray(m,v)
	local array = {}
	for i = 1, m do
		array[i] = 0 or v
	end
	return array
end

function doubleArray(m,n,k)
    local array, x, y = {}
    for x = 0, m
		do array[x] = {}
        for y = 0, n do
            array[x][y] = k or 0
        end
    end
    return array
end

function playerdistance(id1,id2)
	local x1 = player(id1,"x")
	local y1 = player(id1,"y")
	local x2 = player(id2,"x")
	local y2 = player(id2,"y")
	local ank = math.abs(x2-x1)
	local ggk = math.abs(y2-y1)
	local hyp = ank^2 + ggk^2
	local dis = math.sqrt(hyp)
	return dis
end

function ptoplayerdistance(id1,x,y)
	x1 = player(id1,"x")
	y1 = player(id1,"y")
	x2 = x
	y2 = y
	ank = math.abs(x2-x1)
	ggk = math.abs(y2-y1)
	hyp = ank^2 + ggk^2
	dis = math.sqrt(hyp)
	return dis
end

function string.split(text,b)
	local cmd = {}
	if b then
		b = b
	else
		b = "%s"
	end
	b = "[^"..b.."]+"
	for o in string.gmatch(text,b) do
		table.insert(cmd,o)
	end
	return cmd
end


-- Menus --

function mainmenu(id)
	menu(id,"Mainmenu,Statsmenu,Skillmenu,Select Quickspell,,Exp: "..newexp[id].." / "..newneedexp[id]..",Save Game,,Reset Settings|Skills/Stats,Help")	
end


function statsmenu(id)
	menu(id,"Set your Stats@b,Statpoints: "..pts[id].."|,,Health: "..hp[id]..",Mana: "..mana[id]..",,ATK: "..atk[id]..",DEF: "..def[id]..",SPD: "..spd[id].."")	
end


function espellmenu(id)
	menu(id,"Select a Spell@b,"..SPELLS[1].name.."|Which spell would you like to cast by pressing 'E',"..SPELLS[2].name..","..SPELLS[3].name..","..SPELLS[4].name..","..SPELLS[5].name..","..SPELLS[6].name..","..SPELLS[7].name..",,Next ")	
end


function espellmenu2(id)
	menu(id,"Select a Spell 2@b,"..SPELLS[8].name.."|Which spell would you like to cast by pressing 'E',"..SPELLS[9].name..","..SPELLS[10].name..","..SPELLS[11].name..","..SPELLS[12].name..","..SPELLS[13].name..","..SPELLS[14].name..",, Prev")	
end


function skillmenu(id)
	menu(id,"Skillmenu,Slot 1|Select a Slot,Slot 2,Slot 3,Slot 4,Slot 5,Slot 6,Slot 7,Slot 8,Slot 9")	
end


function spellmenu(id)
	menu(id,"Spellmenu,"..SPELLS[1].name..","..SPELLS[2].name..","..SPELLS[3].name..","..SPELLS[4].name..","..SPELLS[5].name..","..SPELLS[6].name..","..SPELLS[7].name..",,Next ")	
end


function spellmenu2(id)
	menu(id,"Spellmenu 2,"..SPELLS[8].name..","..SPELLS[9].name..","..SPELLS[10].name..","..SPELLS[11].name..","..SPELLS[12].name..","..SPELLS[13].name..","..SPELLS[14].name..",, Prev")	
end


function resetmenu(id)
	menu(id,"Resetmenu,Reset Spells,Reset Stats,,,,,,,Reset GAME|Back to lvl 1")	
end




-- Other --

function spelltoslot(id,spellid,slot2)
	slot[id][slot2] = spellid
end


function used(id)
	ptsused[id] = 1
	msg2(id,"000255000You used all of your Statpoints!@C")
end


function HUD()
	for i = 1,32 do
		parse('hudtxt2 '..i..' 1 "250250250'..hp2[i]..' / '..hp[i]..'" 357 406 1')
		parse('hudtxt2 '..i..' 2 "250250250'..mana2[i]..' / '..mana[i]..'" 357 424 1')
		if espellon[i] == 1 then
			espellcd[i] = cdtime[i][espell[i]]
			if espellcd[i] == " " or espellcd[i] == 0 then
				espellcd[i] = "Ready"
			end
			parse('hudtxt2 '..i..' 40 "200200200'..SPELLS[espell[i]].name..' ('..espellcd[i]..')" 103 423 1')
		end
		if espellon[i] == 0 then
			parse('hudtxt2 '..i..' 40 " " 1 1')
		end
		if player(i,"exists") then
			UpdateBars(i)
		end
		parse('hudtxt2 '..i..' 41 "250250250'..lvl[i]..'" 464 424 1')
		parse('hudtxt2 '..i..' 42 "250250250'..newexp[i]..'" 254 424 1')
	end
end


button = doubleArray(32,9)

for i = 1,32 do
	for o = 1,9 do
		for z = 1,32 do
			if i == z then
				button[i][o] = o+(z*9-9)
			end
		end
	end
end

function HUD2(id)
	vl.createButton(button[id][1],id,224,459,slot[id][1],nil,function() SPELLS[slot[id][1]].func(vl.buttonclicker[button[id][1]]) end)
	vl.createButton(button[id][2],id,258,459,slot[id][2],nil,function() SPELLS[slot[id][2]].func(vl.buttonclicker[button[id][2]]) end)
	vl.createButton(button[id][3],id,292,459,slot[id][3],nil,function() SPELLS[slot[id][3]].func(vl.buttonclicker[button[id][3]]) end)
	vl.createButton(button[id][4],id,326,459,slot[id][4],nil,function() SPELLS[slot[id][4]].func(vl.buttonclicker[button[id][4]]) end)
	vl.createButton(button[id][5],id,360,459,slot[id][5],nil,function() SPELLS[slot[id][5]].func(vl.buttonclicker[button[id][5]]) end)
	vl.createButton(button[id][6],id,394,459,slot[id][6],nil,function() SPELLS[slot[id][6]].func(vl.buttonclicker[button[id][6]]) end)
	vl.createButton(button[id][7],id,428,459,slot[id][7],nil,function() SPELLS[slot[id][7]].func(vl.buttonclicker[button[id][7]]) end)
	vl.createButton(button[id][8],id,462,459,slot[id][8],nil,function() SPELLS[slot[id][8]].func(vl.buttonclicker[button[id][8]]) end)
	vl.createButton(button[id][9],id,496,459,slot[id][9],nil,function() SPELLS[slot[id][9]].func(vl.buttonclicker[button[id][9]]) end)
end


function delete_HUD2(id)
	vl.removeButton(button[id][1])
	vl.removeButton(button[id][2])
	vl.removeButton(button[id][3])
	vl.removeButton(button[id][4])
	vl.removeButton(button[id][5])
	vl.removeButton(button[id][6])
	vl.removeButton(button[id][7])
	vl.removeButton(button[id][8])
	vl.removeButton(button[id][9])
end


function reset_spells(id)
	if growthon[id] >= 1 then
		if cooldown_array[id][2] >= 1 then
			spell_2_end(id)
		end
	end
	if preciseblockon[id] >= 1 then
		if cooldown_array[id][3] >= 1 then
			spell_3_end(id)
		end
	end
	if sprinton[id] >= 1 then
		if cooldown_array[id][5] >= 1 then
			spell_5_end(id)
		end
	end
	if omaon[id] >= 1 then
		if cooldown_array[id][9] >= 1 then
			spell_9_end(id)
		end
	end
end


function reset_cd(id)
	for i = 1, #SPELLS do
		cooldown_array[id][i] = 0
		cd_array[id][i] = 0
	end
	for i = 1,9 do
		slotrecharging[id][i] = 0
	end
end



------------
-- SPELLS --
------------


-- Spell 0 --
--[[ Empty / Question mark ]] --
function spell_0(id)
	msg2(id,"162209254F2 -> Skillmenu to add spells!")
end


-- Spell 1 --
--[[ Selfheal ]]
function spell_1(id)
	if cooldown_array[id][1] == 0 then
		if mana2[id] >= SPELLS[1].mana then
			if (hp2[id]+SPELLS[1].power) < hp[id] then
				hp2[id] = hp2[id] + SPELLS[1].power
			else
				hp2[id] = hp[id]
			end
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 16 250 250 250")
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 32 200 255 200")
			cooldown_array[id][1] = 1
			mana2[id] = mana2[id] - SPELLS[1].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/heal.wav\"")
			for i = 1,9 do
				if slot[id][i] == 1 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[1].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 2 --
-- [[ Growth ]]
function spell_2(id) 
	if cooldown_array[id][2] == 0 then
		if mana2[id] >= SPELLS[2].mana then
			atk[id] = atk[id] + SPELLS[2].power
			growthon[id] = 1
			parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 1 1 250 000 000")
			cooldown_array[id][2] = 1
			mana2[id] = mana2[id] - SPELLS[2].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/monster.wav\"")
			aura_atk()
			tween_alpha(atkaura[id], 250, 0.7)
			for i = 1,9 do
				if slot[id][i] == 2 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[2].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end

function spell_2_end(id)
	if growthon[id] == 1 then
		atk[id] = atk[id] - SPELLS[2].power
		tween_alpha(atkaura[id], 400, 0)
		growthon[id] = 0
	end
end


-- Spell 3 --
-- [[ Precise Block ]]
function spell_3(id)
	if cooldown_array[id][3] == 0 then
		if mana2[id] >= SPELLS[3].mana then
			def[id] = def[id] + SPELLS[3].power
			preciseblockon[id] = 1
			parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 1 1 000 000 250")
			cooldown_array[id][3] = 1
			mana2[id] = mana2[id] - SPELLS[3].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/blow.wav\"")
			aura_def()
			tween_alpha(defaura[id], 250, 1)
			for i = 1,9 do
				if slot[id][i] == 3 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[3].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end

function spell_3_end(id)
	if preciseblockon[id] == 1 then
		def[id] = def[id] - SPELLS[3].power
		tween_alpha(defaura[id], 400, 0)
		preciseblockon[id] = 0
	end
end


-- Spell 4 --
-- [[ Meteor ]]
function spell_4(id)
	if cooldown_array[id][4] == 0 then
		if mana2[id] >= SPELLS[4].mana then
			meteor[id] = 1
			tween_alpha(meteorimg[id],200,1)
			cooldown_array[id][4] = 1
			mana2[id] = mana2[id] - SPELLS[4].mana
			for i = 1,9 do
				if slot[id][i] == 4 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[4].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 5 --
-- [[ Sprint ]]
function spell_5(id)
	if cooldown_array[id][5] == 0 then
		if mana2[id] >= SPELLS[5].mana then
			spd[id] = spd[id] + SPELLS[5].power
			sprinton[id] = 1
			parse("speedmod "..id.." "..spd[id].."")
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 1 200 200 200")
			cooldown_array[id][5] = 1
			mana2[id] = mana2[id] - SPELLS[5].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/woosh.wav\"")
			aura_spd()
			tween_alpha(spdaura[id], 400, 0.65)
			for i = 1,9 do
				if slot[id][i] == 5 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[5].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end

function spell_5_end(id)
	if sprinton[id] == 1 then
		spd[id] = spd[id] - SPELLS[5].power
		parse("speedmod "..id.." "..spd[id].."")
		tween_alpha(spdaura[id], 300, 0)
		sprinton[id] = 0
	end
end


-- Spell 6 --
-- [[ Lifesaver ]]
function spell_6(id)
	if cooldown_array[id][6] == 0 then
		if mana2[id] >= SPELLS[6].mana then
			hp2[id] = hp2[id] + (math.ceil(hp[id] * SPELLS[6].power))
			if hp2[id] > hp[id] then
				hp2[id] = hp[id]
			end
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 90 250 250 250")
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 60 175 255 175")
			cooldown_array[id][6] = 1
			mana2[id] = mana2[id] - SPELLS[6].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/heal.wav\"")
			healaura[id]=image("gfx/tajifuns_rpg/flare5.bmp", player(id,"x"), player(id,"y"), 0)
			imagecolor(healaura[id],255,255,255)
			imageblend(healaura[id],1)
			imagealpha(healaura[id],0.6)
			imagescale(healaura[id], 0.1, 0.1)
			tween_alpha(healaura[id], 2000, 0)
			tween_rotateconstantly(healaura[id],1)
			tween_scale(healaura[id],2000,1,1)
			for i = 1,9 do
				if slot[id][i] == 6 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[6].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 7 --
-- [[ Ambitious Sacrifice ]]
function spell_7(id)
	if cooldown_array[id][7] == 0 then
		if mana2[id] >= SPELLS[7].mana then
			if hp2[id] > SPELLS[7].power then
				hp2[id] = hp2[id] - SPELLS[7].power
				cooldown_array[id][7] = 1
				mana2[id] = mana2[id] + SPELLS[7].power2
				if mana2[id] > mana[id] then
					mana2[id] = mana[id]
				end
				mana2[id] = mana2[id] - SPELLS[7].mana
				parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 1 1 255 000 000")
				parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 64 1 000 000 255")
				parse("sv_sound2 "..id.." \"tajifuns_rpg/whip.wav\"")
				for i = 1,9 do
					if slot[id][i] == 7 then
						slotrecharging[id][i] = 1
					end
				end
			else
				msg2(id,"255000000Not enough Health!@C")
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[7].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 8 -- 
-- [[ Sultar's Terror ]]
function spell_8(id)
	if cooldown_array[id][8] == 0 then
		if mana2[id] >= SPELLS[8].mana then
			parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 10 128 154 205 050")
			parse("explosion "..player(id,"x").." "..player(id,"y").." "..SPELLS[8].range.." "..SPELLS[8].power.." "..id.."")
			cooldown_array[id][8] = 1
			mana2[id] = mana2[id] - SPELLS[8].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/laugh.wav\"")
			for i = 1,9 do
				if slot[id][i] == 8 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[8].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 9 --
-- [[ One-Man-Army ]]
function spell_9(id)
	if cooldown_array[id][9] == 0 then
		if mana2[id] >= SPELLS[9].mana then
			dmg_ref[id] = 1
			omaon[id] = 1
			aura_oma()
			tween_alpha(oma[id], 500, 0.75)
			tween_scale(oma[id],(SPELLS[9].time*1000),0.01,0.01)
			parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 64 1 150 150 150")
			cooldown_array[id][9] = 1
			mana2[id] = mana2[id] - SPELLS[9].mana
			parse("sv_sound2 "..id.." \"tajifuns_rpg/shield.ogg\"")
			for i = 1,9 do
				if slot[id][i] == 9 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[9].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end

function spell_9_end(id) 
	if omaon[id] == 1 then
		dmg_ref[id] = 0
		tween_alpha(oma[id], 400, 0)
		omaon[id] = 0
	end
end


-- Spell 10 --
-- [[ Inertia ]] --
function spell_10(id)
	if cooldown_array[id][10] == 0 then
		if mana2[id] >= SPELLS[10].mana then
			
			inertiaimg[id] = image("gfx/tajifuns_rpg/inertia.png",player(id,"x"),player(id,"y"),0)
			tween_scale(inertiaimg[id],2000,0.7,0.7)
			tween_alpha(inertiaimg[id],2000,0)
			tween_rotateconstantly(inertiaimg[id],8)
			for i = 1, 32 do
				if player(i,"exists") then
					if i ~= id then
						if playerdistance(id,i) <= SPELLS[10].range then
							inertiaon[i] = 1
							inertiaspd[i] = inertiaspd[i] + SPELLS[10].power
							aura_inertia()
							imagealpha(inertiaonimg[i],0.8)
							tween_alpha(inertiaonimg[i],10000,0)
							parse("speedmod "..id.." "..inertiaspd[id].."")
							parse("sv_sound2 "..i.." \"tajifuns_rpg/inertia.wav\"")
						end
					end
				end
			end
			parse("sv_sound2 "..id.." \"tajifuns_rpg/inertia.wav\"")
			mana2[id] = mana2[id] - SPELLS[10].mana
			cooldown_array[id][10] = 1
			for i = 1,9 do
				if slot[id][i] == 10 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[10].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 11 --
-- [[ Shield Wall ]] --
function spell_11(id)
	if cooldown_array[id][11] == 0 then
		if mana2[id] >= SPELLS[11].mana then
			for i = 1, 32 do
				if player(i,"exists") then
					if i ~= id then
						if playerdistance(id,i) <= SPELLS[11].range then
							if player(i,"team") == player(id,"team") then
								shieldwall[i] = 1
							end
						end
					end
				end
			end
			-- Wall
			shieldwallimg[id] = image("gfx/tajifuns_rpg/shieldwall.png",player(id,"x"),player(id,"y"),3)
			imagecolor(shieldwallimg[id],35,35,255)
			imagescale(shieldwallimg[id],0.1,0.1)
			imagealpha(shieldwallimg[id],0.7)
			imageblend(shieldwallimg[id],1)
			tween_alpha(shieldwallimg[id],900,0)
			tween_scale(shieldwallimg[id],900,1.2,1.2)
			-- Shield
			shieldwallimg2[id] = image("gfx/tajifuns_rpg/shield.png",player(id,"x"),player(id,"y"),3)
			imagecolor(shieldwallimg2[id],90,90,255)
			imagescale(shieldwallimg2[id],0.7,0.7)
			imagealpha(shieldwallimg2[id],1)
			imageblend(shieldwallimg2[id],1)
			tween_alpha(shieldwallimg2[id],1500,0)
			tween_scale(shieldwallimg2[id],1700,1.1,1.1)
			
			mana2[id] = mana2[id] - SPELLS[11].mana
			cooldown_array[id][11] = 1
			parse("sv_sound2 "..id.." \"tajifuns_rpg/shieldwall.wav\"")
			for i = 1,9 do
				if slot[id][i] == 11 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[11].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 12 --
-- [[ Spiking Ivy ]] --
function spell_12(id)
	if cooldown_array[id][12] == 0 then
		if mana2[id] >= SPELLS[12].mana then
			ivy[id] = 1
			tween_alpha(ivyimg[id],200,1)
			mana2[id] = mana2[id] - SPELLS[12].mana
			cooldown_array[id][12] = 1
			parse("sv_sound2 "..id.." \"tajifuns_rpg/spikingivy1.ogg\"")
			for i = 1,9 do
				if slot[id][i] == 12 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[12].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 13 --
-- [[ Vampirism ]] --
function spell_13(id)
	if cooldown_array[id][13] == 0 then
		if mana2[id] >= SPELLS[13].mana then
			for i = 1, 32 do
				if player(i,"exists") then
					if i ~= id then
						if playerdistance(id,i) <= SPELLS[13].range then
							if player(i,"team") ~= player(id,"team") then
								vampimg[id][i] = image("gfx/tajifuns_rpg/vampimg.bmp",player(i,"x"),player(i,"y"),3)
								imagecolor(vampimg[id][i],255,0,0)
								imagescale(vampimg[id][i],0.5,0.5)
								imagealpha(vampimg[id][i],0.9)
								imageblend(vampimg[id][i],1)
								tween_move(vampimg[id][i],1000,player(id,"x"),player(id,"y"))
								tween_alpha(vampimg[id][i],1000,0)
								if playerdistance(id,i) <= 96 then
									healthplus = 10
								end
								if playerdistance(id,i) <= 64 then
									healthplus = 20
								end
								if playerdistance(id,i) <= 32 then
									healthplus = 30
								end
								hp2[id] = hp2[id] + healthplus
								hp2[i] = hp2[i] - healthplus
								if hp2[i] <= 0 then
									parse('customkill '..id..' "killed" '..i..'')
									add = expratio+math.random(-10,15)
									exp[id] = exp[id] + add
									newexp[id] = newexp[id] + add
									if exp[id] >= needexp[id] then
										lvlup(id)
									end
								end
								if hp2[id] > hp[id] then
									hp2[id] = hp[id]
								end
							end
						end
					end
				end
			end
			mana2[id] = mana2[id] - SPELLS[13].mana
			cooldown_array[id][13] = 1
			parse("sv_sound2 "..id.." \"tajifuns_rpg/vampirism.ogg\"")
			for i = 1,9 do
				if slot[id][i] == 13 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[13].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end


-- Spell 14 --
-- [[ Magical Barrier ]] --
function spell_14(id)
	if cooldown_array[id][14] == 0 then
		if mana2[id] >= SPELLS[14].mana then
			barrierimg[id] = image("gfx/tajifuns_rpg/barrier.png",player(id,"x"),player(id,"y"),3)
			tween_alpha(barrierimg[id],400,0)
			barrier[id] = SPELLS[14].power
			mana2[id] = mana2[id] - SPELLS[14].mana
			cooldown_array[id][14] = 1
			parse("sv_sound2 "..id.." \"tajifuns_rpg/magicalbarrier.wav\"")
			for i = 1,9 do
				if slot[id][i] == 14 then
					slotrecharging[id][i] = 1
				end
			end
		else
			msg2(id,"255000000Not enough Mana! You need "..SPELLS[14].mana.." Mana.@C")
		end
	else
		msg2(id,"255000000Spell needs to restore!@C")
	end
end



-- AURA --

function aura_oma()
	for i=1,32 do
		if player(i,"exists") then
			oma[i]=image("gfx/tajifuns_rpg/flare5.bmp",0,0,100+i)	-- Create image @ Player
			imagecolor(oma[i],255,255,560)							-- Make image yellow
			imagescale(oma[i],0.4,0.4)
			imageblend(oma[i],1)									-- Make image glow
			imagealpha(oma[i],0)									-- Decrease Glow Strength
			tween_rotateconstantly(oma[i],2)
		end
	end
end


function aura_def()
	for i=1,32 do
		if player(i,"exists") then
			defaura[i]=image("gfx/tajifuns_rpg/defensiveaura.png",0,0,100+i)
			imagescale(defaura[i],0.8,0.8)
			imagealpha(defaura[i],0)
			tween_rotateconstantly(defaura[i],3)
		end
	end
end


function aura_atk()
	for i=1,32 do
		if player(i,"exists") then
			atkaura[i]=image("gfx/tajifuns_rpg/growth.png",0,0,100+i)	
			imagescale(atkaura[i],0.6,0.6)
			imagealpha(atkaura[i],0)
			tween_rotateconstantly(atkaura[i],-5)
		end
	end
end


function aura_spd()
	for i=1,32 do
		if player(i,"exists") then
			spdaura[i]=image("gfx/tajifuns_rpg/sprint.png",1,0,100+i)	
			imagescale(spdaura[i],0.7,0.7)
			imagealpha(spdaura[i],0)
		end
	end
end


function aura_ivy()
	for i=1,32 do
		if player(i,"exists") then
			ivyonimg[i]=image("gfx/tajifuns_rpg/ivyonimg.png",player(i,"x"),player(i,"y"),0)	
			imagescale(ivyonimg[i],0.9,0.9)
			imagealpha(ivyonimg[i],0)
		end
	end
end


function aura_inertia()
	for i=1,32 do
		if player(i,"exists") then
			inertiaonimg[i]=image("gfx/tajifuns_rpg/inertiaon.png",0,1,100+i)
			tween_rotateconstantly(inertiaonimg[i],2)			
			imagescale(inertiaonimg[i],0.8,0.8)
			imagealpha(inertiaonimg[i],0)
		end
	end
end


function interface(id)
	gui[id]=image("gfx/tajifuns_rpg/gui.png",1,0,2,i)
	imagepos(gui[id],320,240,0)
end


function lvlup(id)
	needexp[id] = math.floor(lvl[id] * lvlratio)
	newneedexp[id] = math.floor(newexp[id] + lvl[id] * lvlratio)
	lvl[id] = lvl[id] + 1
	pts[id] = pts[id] + ptsalvl
	exp[id] = 0
	ptsused[id] = 0
	parse("sv_sound2 "..id.." \"tajifuns_rpg/levelup.wav\"")
	msg2(id,"000240000Level up!@C")
end


function save(id)
	local name = player(id,"name")
	local usgn = player(id,"usgn")
	if usgn > 0 then
          io.output(io.open("sys/lua/tajifuns_rpg2.0/trpg_saves/"..usgn..".txt","w+"))
          io.write(lvl[id].." "..exp[id].." "..newexp[id].." "..needexp[id].." "..newneedexp[id].." "..slot[id][1].." "..slot[id][2].." "..slot[id][3].." "..slot[id][4].." "..slot[id][5].." "..slot[id][6].." "..slot[id][7].." "..slot[id][8].." "..slot[id][9])
          io.close()
     end
	 msg2(id,"000255000Saved your stats!@C")
end


function load(id)
	if player(id,"usgn") > 0 then
		local filename = "sys/lua/tajifuns_rpg2.0/trpg_saves/%s.txt"
		local file = io.open(filename:format(player(id,"usgn"),"r"))
		local line
		if not file then
			line = {1, 0, 0, 250, 250, 0, 0, 0, 0, 0, 0, 0, 0, 0}
			lvl[id] = tonumber(line[1])
			if lvl[id] == 0 then
				lvl[id] = 1
			end
			exp[id] = tonumber(line[2])
			newexp[id] = tonumber(line[3]) 
			needexp[id] = tonumber(line[4])
			newneedexp[id] = tonumber(line[5])
			slot[id][1] = tonumber(line[6])
			slot[id][2] = tonumber(line[7])
			slot[id][3] = tonumber(line[8])
			slot[id][4] = tonumber(line[9])
			slot[id][5] = tonumber(line[10])
			slot[id][6] = tonumber(line[11])
			slot[id][7] = tonumber(line[12])
			slot[id][8] = tonumber(line[13])
			slot[id][9] = tonumber(line[14])
			msg2(id,"255000000Failed to load!@C")
			msg2(id,"255100100Creating save data...@C")
			save(id)
		else
			line = file:read("*a"):split()
			lvl[id] = tonumber(line[1])
			if lvl[id] == 0 then
				lvl[id] = 1
			end
			exp[id] = tonumber(line[2])
			newexp[id] = tonumber(line[3]) 
			needexp[id] = tonumber(line[4])
			newneedexp[id] = tonumber(line[5])
			slot[id][1] = tonumber(line[6])
			slot[id][2] = tonumber(line[7])
			slot[id][3] = tonumber(line[8])
			slot[id][4] = tonumber(line[9])
			slot[id][5] = tonumber(line[10])
			slot[id][6] = tonumber(line[11])
			slot[id][7] = tonumber(line[12])
			slot[id][8] = tonumber(line[13])
			slot[id][9] = tonumber(line[14])
			delete_HUD2(id)
			HUD2(id)
			msg2(id,"000255000Stats loaded succesfully!@C")	
		end
	else
		msg2(id,"255000000Failed to load! No USGN login!@C")
		lvl[id] = 1
		needexp[id] = lvlratio
		newneedexp[id] = lvlratio
		exp[id] = 0
		newexp[id] = 0
	end
end


function help(id)
	msg2(id,"040180255---- Help ----")
	msg2(id,"040180255[F2] - Mainmenu")
	msg2(id,"040180255[F3] - Quickspell on/off")
	msg2(id,"040180255This script is made by Tajifun")
	msg2(id,"040180255I hope you like it")
	msg2(id,"040180255--------------")
end


function resetgame(id)
	for i = 1, 9 do
		slot[id][i] = 0
	end
	delete_HUD2(id)
	HUD2(id)
	hp[id] = b_hp
	mana[id] = b_mana
	atk[id] = b_atk
	def[id] = b_def
	spd[id] = b_spd
	pts[id] = startpts
	ptsused[id] = 0
	lvl[id] = 1
	exp[id] = 0
	newexp[id] = 0
	needexp[id] = lvlratio
	newneedexp[id] = lvlratio
	msg2(id,"000255000You resetted your game succesfully!@C")
end


function resetspells(id)
	for i = 1, 9 do
		if slotrecharging[id][i] == 0 then
			slot[id][i] = 0
		else
			msg2(id,"255000000You have to wait until every spell is recharged!@C")
		end
	end
	delete_HUD2(id)
	HUD2(id)
end


function resetstats(id)
	hp[id] = b_hp
	mana[id] = b_mana
	atk[id] = b_atk
	def[id] = b_def
	spd[id] = b_spd
	pts[id] = startpts+(ptsalvl*(lvl[id]-1))
	ptsused[id] = 0
end








