
--[[
The basic construction of this part is made by failbit.
Thank you. :)
]]


bar = initArray(32)

local HpbarHeight = 14;
local HpbarWidth = 100;
local HpbarPosX = 308;
local HpbarPosY = 407;

local ManabarHeight = 14;
local ManabarWidth = 100;
local ManabarPosX = 308;
local ManabarPosY = 424;

local ExpbarHeight = 14;
local ExpbarWidth = 63;
local ExpbarPosX = 223;
local ExpbarPosY = 424;



function DrawRect(x,y,w,h,id,rgb,l)
	id = id or 0;
	l = l or 2;
	rgb = rgb or {255,255,255};
	local img = image("gfx/tajifuns_rpg/plot.bmp", x+(w/2), y+(h/2), l, id);
	imagescale(img, w, h);
	imagecolor(img, rgb[1], rgb[2], rgb[3]);
	return img;
end


function UpdateRect(id, x, y, w, h, rgb)
	rgb = rgb or {255, 255, 255};
	imagepos(id, x+(w/2), y+(h/2), 0);
	imagescale(id, w, h);
	imagecolor(id, rgb[1], rgb[2], rgb[3]);
end


function removeRects(id)
	freeimage(hpBarImg[id][1])
	freeimage(hpBarImg[id][2])
	freeimage(manaBarImg[id][2])
	freeimage(manaBarImg[id][2])
	freeimage(expBarImg[id][2])
	freeimage(expBarImg[id][2])
end


hpBarImg = doubleArray(32,2)
manaBarImg = doubleArray(32,2)
expBarImg = doubleArray(32,2)


function DrawRects(id)
	hpBarImg[id][1] = DrawRect(0, 0, 0, 0, id, {50, 50, 50}, 2)
	hpBarImg[id][2] = DrawRect(0, 0, 0, 0, id, {255, 0, 0}, 2)
	imagealpha(hpBarImg[id][1], 1);

	manaBarImg[id][1] = DrawRect(0, 0, 0, 0, id, {50, 50, 50}, 2);
	manaBarImg[id][2] = DrawRect(0, 0, 0, 0, id, {0, 0, 255}, 2);
	imagealpha(manaBarImg[id][1], 1);
			
	expBarImg[id][1] = DrawRect(0, 0, 0, 0, id, {50, 50, 50}, 2);
	expBarImg[id][2] = DrawRect(0, 0, 0, 0, id, {0, 245, 0}, 2);
	imagealpha(expBarImg[id][1], 1);
end
	
	
function UpdateBars(id)
	if player(id, "exists") then
		local hpRatio = hp2[id]/hp[id];
		UpdateRect(hpBarImg[id][1], HpbarPosX, HpbarPosY, HpbarWidth, HpbarHeight, {50, 50, 50});
		UpdateRect(hpBarImg[id][2], HpbarPosX, HpbarPosY, hpRatio*HpbarWidth, HpbarHeight, {225, 0, 0});

		local manaRatio = mana2[id]/mana[id];
		UpdateRect(manaBarImg[id][1], ManabarPosX, ManabarPosY, ManabarWidth, ManabarHeight, {50, 50, 50});
		UpdateRect(manaBarImg[id][2], ManabarPosX, ManabarPosY, manaRatio*ManabarWidth, ManabarHeight, {25, 25, 255});
			
		local expRatio = exp[id] / needexp[id]
		UpdateRect(expBarImg[id][1], ExpbarPosX, ExpbarPosY, ExpbarWidth, ExpbarHeight, {50, 50, 50});
		UpdateRect(expBarImg[id][2], ExpbarPosX, ExpbarPosY, expRatio*ExpbarWidth, ExpbarHeight, {0, 255, 0});
	end
end




