
-------------------------
--					   --
-- Tajifun's RPG Mod   --
-- v2.0 		   	   --
-------------------------


-- REMOVE ME
--[[
 
 eine art krp einfhren?

]]




print("000255000Loading Tajifun's RPG...")
path = "sys/lua/tajifuns_rpg2.0/trpg_"

dofile(""..path.."VisualLua.lua")
print("000255000trpg_VisualLua.lua loaded succesfully!")

dofile(""..path.."functions.lua")
print("000255000trpg_functions.lua loaded succesfully!")


-----------
-- Setup --
-----------

adtime = 0

updaterate = 100

startpts = 30 		-- Statpoints at start (default: 30)

maxpt_hp = 150		-- Max. Health 	(default: 150)
maxpt_mana = 600	-- Max. Mana	(default: 600)
maxpt_atk = 25		-- Max. Attack	(default: 25)
maxpt_def = 25		-- Max. Defense	(default: 25)
maxpt_spd = 20		-- Max. Speed	(default: 20)

b_hp = 100			-- Basic Health	(default: 100)
b_mana = 500		-- Basic Mana 	(default: 500)
b_atk = 10			-- Basic Attack	(default: 10)
b_def = 10			-- Basic Defense(default: 10)
b_spd = 0			-- Basic Speed	(default: 0)

hp_reg = 2 			-- Health regeneration each 2 seconds (- 0-2)
mana_reg = 7 		-- Mana regeneration per second (+/- 2)

expratio = 80
lvlratio = 250
ptsalvl = 2 		-- Statpoints you earn for each lvlup (default: 2)
startlvl = 1
startneedexp = 250


------------
-- Arrays --
------------

vampimg = doubleArray(32,32)
slot = doubleArray(32,9,0)
slotrecharging = doubleArray(32,9)
buttonhudtxt = doubleArray(9,2)

buttonhudtxt[1][1] = 226
buttonhudtxt[1][2] = 461
buttonhudtxt[2][1] = 259
buttonhudtxt[2][2] = 461
buttonhudtxt[3][1] = 293
buttonhudtxt[3][2] = 461
buttonhudtxt[4][1] = 326
buttonhudtxt[4][2] = 461
buttonhudtxt[5][1] = 360
buttonhudtxt[5][2] = 461
buttonhudtxt[6][1] = 393
buttonhudtxt[6][2] = 461
buttonhudtxt[7][1] = 427
buttonhudtxt[7][2] = 461
buttonhudtxt[8][1] = 459
buttonhudtxt[8][2] = 461
buttonhudtxt[9][1] = 492
buttonhudtxt[9][2] = 461

hp = initArray(32)
hp2 = initArray(32)
mana = initArray(32)
mana2 = initArray(32)
atk = initArray(32)
def = initArray(32)
spd = initArray(32)
pts = initArray(32)
ptsused = initArray(32)
dmg_ref = initArray(32)
ownhud = initArray(32)
hpreg = initArray(32)
oma = initArray(32)
healaura = initArray(32)
atkaura = initArray(32)
defaura = initArray(32)
spdaura = initArray(32)
espell = initArray(32)
espellon = initArray(32)
espellcd = initArray(32)
gui = initArray(32)
imgon = initArray(32)
lvl = initArray(32)
exp = initArray(32)
needexp = initArray(32)
newneedexp = initArray(32)
for i = 1,32 do
	newneedexp[i] = lvlratio
end
newexp = initArray(32)
-- skillpt = initArray(32) <-- ?? Maybe in the next version o.O
cursorx = initArray(32)
cursory = initArray(32)
meteor = initArray(32)
meteorimg = initArray(32)
ivy = initArray(32)
ivytimer = initArray(32)
ivyon = initArray(32)
ivyimg = initArray(32)
ivyonimg = initArray(32)
inertiaon = initArray(32)
inertiaonimg = initArray(32)
inertiaimg = initArray(32)
inertiaspd = initArray(32)
freez = initArray(32)
freezon = initArray(32)
tutorial = initArray(32)
selectedslot = initArray(32)
barrier = initArray(32)
barrierimg = initArray(32)
growthon = initArray(32)
preciseblockon = initArray(32)
sprinton = initArray(32)
omaon = initArray(32)
shieldwall = initArray(32)
shieldwalltimer = initArray(32)
shieldwallimg = initArray(32)
shieldwallimg2 = initArray(32)
clearall = initArray(32)



-----------------------
-- [[ SPELL TABLE ]] --
-----------------------

SPELLS = {

	[0] = {
		name = "Empty",
		cd = 0,
		mana = 0,
		power = 0,
		range = 0,
		time = 0,
		func = function(id) spell_0(id) end,
		path = "gfx/tajifuns_rpg/spells/empty.png",
	},

	[1] = {
		name = "Selfheal",
		cd = 45,
		mana = 75,
		power = 30,
		func = function(id) spell_1(id) end,
		path = "gfx/tajifuns_rpg/spells/selfheal.png",
	},
	
	[2] = {
		name = "Growth",
		cd = 60,
		mana = 100,
		power = 15,
		time = 20,
		func = function(id) spell_2(id) end,
		path = "gfx/tajifuns_rpg/spells/growth.png",
	},
	
	[3] = {
		name = "Precise Block",
		cd = 60,
		mana = 100,
		power = 15,
		time = 20,
		func = function(id) spell_3(id) end,
		path = "gfx/tajifuns_rpg/spells/preciseblock.png",
	},
	
	[4] = {
		name = "Meteor",
		cd = 60,
		mana = 150,
		power = 35,
		range = 64,
		func = function(id) spell_4(id) end,
		path = "gfx/tajifuns_rpg/spells/meteor.png",
	},
	
	[5] = {
		name = "Sprint",
		cd = 30,
		mana = 75,
		power = 10,
		time = 10,
		func = function(id) spell_5(id) end,
		path = "gfx/tajifuns_rpg/spells/sprint.png",
	},
	
	[6] = {
		name = "Lifesaver",
		cd = 90,
		mana = 175,
		power = 0.6,
		func = function(id) spell_6(id) end,
		path = "gfx/tajifuns_rpg/spells/lifesaver.png",
	},
	
	[7] = {
		name = "Ambitious Sacrifice",
		cd = 25,
		mana = 0,
		power = 25,
		power2 = 150,
		func = function(id) spell_7(id) end,
		path = "gfx/tajifuns_rpg/spells/ambitioussacrifice.png",
	},
	
	[8] = {
		name = "Sultar's Terror",
		cd = 120,
		mana = 275,
		power = 200,
		range = 160,
		func = function(id) spell_8(id) end,
		path = "gfx/tajifuns_rpg/spells/sultarsterror.png",
	},
	
	[9] = {
		name = "One-Man-Army",
		cd = 180,
		mana = 350,
		power = 90,
		time = 7,
		func = function(id) spell_9(id) end,
		path = "gfx/tajifuns_rpg/spells/oma.png",
	},
	
	[10] = {
		name = "Inertia",
		cd = 75,
		mana = 140,
		power = -20,
		range = 72,
		func = function(id) spell_10(id) end,
		path = "gfx/tajifuns_rpg/spells/inertia.png",
	},
	
	[11] = {
		name = "Shield Wall",
		cd = 85,
		mana = 175,
		power = 0.35,
		time = 5,
		range = 96,
		func = function(id) spell_11(id) end,
		path = "gfx/tajifuns_rpg/spells/shieldwall.png",
	},
	
	[12] = {
		name = "Spiking Ivy",
		cd = 70,
		mana = 170,
		power = -100,
		time = 3,
		range = 64,
		func = function(id) spell_12(id) end,
		path = "gfx/tajifuns_rpg/spells/spikingivy.png",
	},
	
	[13] = {
		name = "Vampirism",
		cd = 80,
		mana = 175,
		power = 50,
		range = 96,
		func = function(id) spell_13(id) end,
		path = "gfx/tajifuns_rpg/spells/vampirism.png",
	},
	
	[14] = {
		name = "Magical Barrier",
		cd = 95,
		mana = 180,
		power = 100,
		func = function(id) spell_14(id) end,
		path = "gfx/tajifuns_rpg/spells/magicalbarrier.png",
	},
}


cd_array = doubleArray(32,#SPELLS,0)
cooldown_array = doubleArray(32,#SPELLS,0)
cdtime = doubleArray(32,#SPELLS,0)



dofile(""..path.."engine.lua")
print("000255000trpg_engine.lua loaded succesfully!")

dofile(""..path.."hpBar.lua")
print("000255000trpg_hpBar.lua loaded succesfully!")


print("000255000Tajifun's RPG loaded succesfully!")